//
//  CartCell.m
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "CartCell.h"

#import "UIImageView+WebCache.h"
#import "ServerSettingsManager.h"



@implementation CartCell

- (void)dealloc {
    [_removeButton release];
    [_cartItem release];
    [_lblName release];
    [_lblDescription release];
    [_lblPrice release];
    [_ivImage release];
    
    [super dealloc];
}



- (void)setCartItem:(CartItem *)cartItem {
    [cartItem retain];
    [_cartItem release];
    _cartItem = cartItem;
    
    self.lblName.text = cartItem.goods.name;
    self.lblDescription.text = cartItem.goods.desc;
    self.lblPrice.text = [NSString stringWithFormat:@"%@ X %d = %@", [[ServerSettingsManager sharedInstance] stringForPrice:cartItem.goods.price], (int)cartItem.count,
                          [[ServerSettingsManager sharedInstance] stringForPrice:cartItem.goods.price * cartItem.count]];
    
    if (cartItem.goods.imageUrl)
        [self.ivImage setImageWithURL:cartItem.goods.imageUrl];
}

@end
