//
//  OrderCell.m
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "OrderCell.h"

#import "NSDate+Formatting.h"
#import "ServerSettingsManager.h"


@interface OrderCell ()

@property (retain, nonatomic) IBOutlet UILabel *lblOrderNo;
@property (retain, nonatomic) IBOutlet UILabel *lblAmount;
@property (retain, nonatomic) IBOutlet UILabel *lblDate;
@property (retain, nonatomic) IBOutlet UILabel *lblStatus;

@end




@implementation OrderCell

- (void)dealloc {
    [_order release];
    
    [_lblOrderNo release];
    [_lblAmount release];
    [_lblDate release];
    [_lblStatus release];
    
    [super dealloc];
}



- (void)setOrder:(OrderModel *)order {
    [order retain];
    [_order release];
    _order = order;
    
    self.lblOrderNo.text = [NSString stringWithFormat:@"Заказ #%d", (int)order.identifier];
    self.lblAmount.text = [[ServerSettingsManager sharedInstance] stringForPrice:order.amount];
    self.lblDate.text = [order.date dateStringWithFormat:@"yyyy'.'MM'.'dd HH':'mm"];
    self.lblStatus.text = [order statusString];
    
    if (order.state == OrderStateDelivered) self.lblStatus.textColor = [UIColor greenColor];
    else if (order.state == OrderStateConfirmed) self.lblStatus.textColor = [UIColor redColor];
    else self.lblStatus.textColor = [UIColor lightGrayColor];
}

@end
