//
//  ServiceRequestBuilder.h
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import <Foundation/Foundation.h>

#import "ServiceManager.h"

#import "ServiceRequest.h"

#import "ServiceResponseModelItems.h"

#import "GoodsModel.h"
#import "OrderModel.h"



@interface ServiceRequestBuilder : NSObject

+ (instancetype)sharedInstance;

- (ServiceRequest *)requestGoods;
- (ServiceRequest *)requestCreateOrder:(NSString *)cart deviceId:(NSString *)deviceId;
- (ServiceRequest *)requestInitiateOrder:(NSUInteger)orderId phone:(NSString *)phone address:(NSString *)address details:(NSString *)details;
- (ServiceRequest *)requestConfirmOrder:(NSUInteger)orderId code:(NSString *)code;
- (ServiceRequest *)requestDiscardOrder:(NSUInteger)orderId;
- (ServiceRequest *)requestOrdersWithDeviceId:(NSString *)deviceId;
- (ServiceRequest *)requestGlobalSettings;

@end
