//
//  ServiceOperation.h
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import <Foundation/Foundation.h>

#import "ServiceGlobals.h"

#import "ServiceOperationDataSource.h"
#import "ServiceOperationDelegate.h"




@interface ServiceOperation : NSOperation

- (instancetype)initWithDataSource:(id<ServiceOperationDataSource>)dataSource delegate:(id<ServiceOperationDelegate>)delegate;

- (void)prepareForQueue;
- (void)cancelDueToFailure;

@property (nonatomic, readwrite, retain) id<ServiceOperationDataSource> dataSource;
@property (nonatomic, readwrite, assign) id<ServiceOperationDelegate> delegate;

@property (nonatomic, readonly, assign) ServiceOperationState state;

@end
