//
//  ServiceRequest.h
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import <Foundation/Foundation.h>

#import "ServiceGlobals.h"
#import "ServiceResponse.h"



@class ServiceRequest;



typedef void (^ServiceRequestCallback)(ServiceRequest *request);



@interface ServiceRequest : NSObject

- (instancetype)initWithSuccessBlock:(ServiceRequestCallback)successBlock failBlock:(ServiceRequestCallback)failBlock;
+ (instancetype)requestWithSuccessBlock:(ServiceRequestCallback)successBlock failBlock:(ServiceRequestCallback)failBlock;


// Request data properties
@property (nonatomic, readwrite, retain) NSString *endpointResource;
@property (nonatomic, readwrite, retain) NSDictionary *getParameters;

@property (nonatomic, readwrite, assign) Class responseClass;
@property (nonatomic, readwrite, retain) id responseParameter;


// Status properties
@property (nonatomic, readonly, assign) ServiceOperationState operationState;
@property (nonatomic, readonly, retain) NSError *error;

@property (nonatomic, readwrite, copy) ServiceRequestCallback successBlock;
@property (nonatomic, readwrite, copy) ServiceRequestCallback failBlock;

@property (nonatomic, readonly, retain) ServiceResponse *response;

@end
