//
//  ServiceResponseModelItems.m
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "ServiceResponseModelItems.h"

#import "DataModel.h"



@interface ServiceResponseModelItems()

@property (nonatomic, readwrite, retain) NSArray *items;

@end



@implementation ServiceResponseModelItems

- (instancetype)initWithData:(NSData *)data statusCode:(NSInteger)statusCode parameter:(id)parameter {
    self = [super initWithData:data statusCode:statusCode parameter:parameter];
    if (self) {
        if (self.error)
            return self;
        
        NSMutableArray *tmpItems = [NSMutableArray array];
        
        Class modelClass = NSClassFromString(parameter);
        for (NSDictionary *itemDict in self.response) {
            id model = [modelClass modelWithDictionary:itemDict];
            [tmpItems addObject:model];
        }
        
        self.items = tmpItems;
    }
    return self;
}



- (void)dealloc {
    [_items release];
    
    [super dealloc];
}

@end
