//
//  X20Engine.m
//  AppPiza
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "ServiceManager.h"

#import "ServiceOperation.h"


@interface ServiceManager ()

@end





@implementation ServiceManager {
    NSOperationQueue *_queue;
}



#pragma mark -
#pragma mark Singleton implementation
static ServiceManager *_sharedInstance = nil;



+ (ServiceManager *)sharedInstance {
    if (!_sharedInstance)
        _sharedInstance = [[ServiceManager alloc] init];
    
    return _sharedInstance;
}


- (id)init {
    self = [super init];
    if (self) {
        _queue = [[NSOperationQueue alloc] init];
    }
    return self;
}


- (void)dealloc {
    [_queue release];
    
    [super dealloc];
}


- (oneway void)release {
}


- (id)retain {
    return self;
}


- (id)autorelease {
    return self;
}


- (NSUInteger)retainCount {
    return INT_MAX;
}



#pragma mark -
#pragma mark Processing requests
- (void)processRequest:(ServiceRequest *)request {
    ServiceOperation *operation = [[ServiceOperation alloc] initWithDataSource:(id)request delegate:(id)request];
    [operation prepareForQueue];
    [_queue addOperation:operation];
}



- (BOOL)cancelRequest:(ServiceRequest *)request {
    BOOL cancelled = NO;
    
    for (ServiceOperation *operation in _queue.operations) {
        if (operation.dataSource == request) {
            [operation cancel];
            cancelled = YES;
        }
    }
    
    return cancelled;
}



- (void)cancelAllRequests {
    [_queue cancelAllOperations];
}

@end
