//
//  NSDate+Formatting.m
//  iSP
//
//  Copyright (c) 2014 CJSC "Computing Forces"
//

#import "NSDate+Formatting.h"


@implementation NSDate (NSDate_Formatting)

+ (NSDate *)parseRFC3339Date:(NSString *)dateString  {
    return [NSDate dateFromString:dateString withFormat:@"yyyy-MM-dd'T'HH:mm:ss.SZ"];
}


+ (NSDate *)dateFromString:(NSString *)dateString withFormat:(NSString *)format timeZone:(NSTimeZone *)timeZone {
    if (!dateString || !format)
        return nil;
    
    NSDateFormatter *rfc3339TimestampFormatterWithTimeZone = [[NSDateFormatter alloc] init];
    [rfc3339TimestampFormatterWithTimeZone setLocale:[[[NSLocale alloc] initWithLocaleIdentifier:@"en_US_POSIX"] autorelease]];
    [rfc3339TimestampFormatterWithTimeZone setDateFormat:format];
    if (timeZone)  rfc3339TimestampFormatterWithTimeZone.timeZone = timeZone;
    
    NSDate *theDate = nil;
    NSError *error = nil;
    if (![rfc3339TimestampFormatterWithTimeZone getObjectValue:&theDate forString:dateString range:nil error:&error]) {
        ///NSLog(@"Date '%@' could not be parsed: %@", dateString, error);
    }
    [rfc3339TimestampFormatterWithTimeZone release];
    
    return theDate;
}



+ (NSDate *)dateFromString:(NSString *)dateString withFormat:(NSString *)format {
    return [NSDate dateFromString:dateString withFormat:format timeZone:[NSTimeZone timeZoneForSecondsFromGMT:0]];
}



- (NSString *)dateStringWithFormat:(NSString *)format {
    NSDateFormatter *df = [[NSDateFormatter alloc] init];
    df.dateFormat = format;
    
    NSString *result = [df stringFromDate:self];
    [df release];
    
    return result;
}

@end
